---
title: "Live Google Autocomplete Advanced"
url: "https://docs.dataforseo.com/v3/serp/google/autocomplete/live/advanced/"
date: "2026-06-06"
---

## Live Google Autocomplete Advanced

  
Google Autocomplete is a feature within Google Search that improves the search experience by allowing users to complete searches they started to type. DataForSEO SERP API will provide you with all the suggestions Google Autocomplete offers for a particular keyword, the position of the cursor pointer, and the search client.

 

 

 ![checked](https://docs.dataforseo.com/v3/wp-content/themes/dataforseo/assets/img/icons/checked-circle.svg) POST  https://api.dataforseo.com/v3/serp/google/autocomplete/live/advanced     

      

Pricing

 Your account will be charged for each request.  
The cost can be calculated on the [Pricing](https://dataforseo.com/pricing/serp/google-autocomplete-serp-api "Pricing") page.

 

 All POST data should be sent in the [JSON](https://en.wikipedia.org/wiki/JSON) format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live SERP API call can contain only one task.

Below you will find a detailed description of the parameters that are required or recommended for setting a task.

Main Parameters

| Field name | Type | Description |
|---|---|---|
| `keyword` | string | *keyword*  **required field**  you can specify **up to 700 characters** in the `keyword` field  all %## will be decoded (plus character ‘+’ will be decoded to a space character)  if you need to use the “%” character for your `keyword`, please specify it as “%25”;  if you need to use the “+” character for your `keyword`, please specify it as “%2B”;     learn more about rules and limitations of `keyword` and `keywords` fields in DataForSEO APIs in this [Help Center article](https://dataforseo.com/help-center/rules-and-limitations-of-keyword-and-keywords-fields-in-dataforseo-apis) |
| `location_code` | integer | *search engine location code*  **required field if you don't specify** `location_name`;  you can receive the list of available locations of the search engines with their `location_code` by making a separate request to `https://api.dataforseo.com/v3/serp/google/locations`  example:  `2840` |
| `language_code` | string | *search engine language code*  **required field if you don't specify** `language_name`  **if you use this field, you don't need to specify `language_name`**;  you can receive the list of available languages of the search engine with their `language_code` by making a separate request to the `https://api.dataforseo.com/v3/serp/google/languages`example:`en` |
| `cursor_pointer` | integer | *search bar cursor pointer*  optional field  the horizontal numerical position of the cursor pointer within the keyword in the search bar;  by modifying the position of the cursor pointer, you will obtain different autocomplete suggestions for the same seed keyword;  minimal value: `0`  default value: the number of the last character of the specified `keyword`  example:  `\|which query are s` - `"cursor_pointer": 0`  `which query is s\|` - `"cursor_pointer": 16`  `which que\|ry is s` - `"cursor_pointer": 9` |



  
Below you will find a drop-down list with the additional parameters you can use for setting a task.  
Additional Parameters| Field name | Type | Description |
|---|---|---|
| `location_name` | string | *full name of search engine location*  **required field if you don't specify** `location_code`  **if you use this field, you don't need to specify `location_code`**;  you can receive the list of available locations of the search engine with their `location_name` by making a separate request to `https://api.dataforseo.com/v3/serp/google/autocomplete/locations`  example:  `London,England,United Kingdom` |
| `language_name` | string | *full name of search engine language*  **required field if you don't specify** `language_code`  **if you use this field, you don't need to specify `language_code`**;  you can receive the list of available languages of the search engine with their `language_name` by making a separate request to `https://api.dataforseo.com/v3/serp/google/languages`  example:  `English` |
| `client` | string | *search client for autocomplete*  optional field  autocomplete results may differ depending on the search client;  possible values:  `chrome` — used when google search is opened in google chrome;  `chrome-omni` — used in the address bar in chrome;  `gws-wiz` — used in google search home page;  `gws-wiz-serp` — used in google search engine results page;  `safari` — used when google search is opened in safari browser;  `firefox` — used when google search is opened in firefox browser;  `psy-ab` — may be used when google search is opened in google chrome browser;  `toolbar` — returns XML;  `youtube` — returns JSONP;  `gws-wiz-local` — used in google local;  `img` — used in google's image search;  `products-cc` — used in google shopping search |
| `tag` | string | *user-defined task identifier*  optional field  *the character limit is 255*  you can use this parameter to identify the task and match it with the result  you will find the specified `tag` value in the `data` object of the response |



  
  
As a response of the API server, you will receive [JSON](https://en.wikipedia.org/wiki/JSON)-encoded data containing a `tasks` array with the information specific to the set tasks. **Description of the fields in the results array:**

| Field name | Type | Description |
|---|---|---|
| `version` | string | *the current version of the API* |
| `status_code` | integer | *general status code*   you can find the full list of the response codes [here](https://docs.dataforseo.com/v3/appendix/errors.md)   **Note:** we strongly recommend designing a necessary system for handling related exceptional or error conditions |
| `status_message` | string | *general informational message*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *total tasks cost, USD* |
| `tasks_count` | integer | *the number of tasks in the **`tasks`** array* |
| `tasks_error` | integer | *the number of tasks in the **`tasks`** array returned with an error* |
| **`tasks`** | array | *array of tasks* |
| `id` | string | *task identifier*   **unique task identifier in our system in the [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier) format** |
| `status_code` | integer | *status code of the task*   generated by DataForSEO; can be within the following range: 10000-60000   you can find the full list of the response codes [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `status_message` | string | *informational message of the task*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *cost of the task, USD* |
| `result_count` | integer | *number of elements in the `result` array* |
| `path` | array | *URL path* |
| `data` | object | *contains the same parameters that you specified in the POST request* |
| **`result`** | array | *array of results* |
| `keyword` | string | *keyword received in a POST array* **the keyword is returned with decoded %## (plus character ‘+’ will be decoded to a space character)** |
| `type` | string | *search engine type in a POST array* |
| `se_domain` | string | *search engine domain in a POST array* |
| `location_code` | integer | *location code in a POST array* |
| `language_code` | string | *language code in a POST array* |
| `check_url` | string | *direct URL to search engine results*   you can use it to make sure that we provided accurate results |
| `datetime` | string | *date and time when the result was received*   in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”   example:   `2019-11-15 12:57:46 +00:00` |
| `spell` | object | *autocorrection of the search engine*   if the search engine provided results for a keyword that was corrected, we will specify the keyword corrected by the search engine and the type of autocorrection;   in this case, will equal `null` |
| `refinement_chips` | object | *search refinement chips* |
| `type` | string | *type of element = **‘refinement\_chips’*** |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `items` | array | *items of the element* |
| `type` | string | *type of element = **‘refinement\_chips\_element’*** |
| `title` | string | *title of the element* |
| `url` | string | *search URL with refinement parameters* |
| `domain` | string | *domain in SERP* |
| `options` | array | *further search refinement options* |
| `type` | string | *type of element = **‘refinement\_chips\_option’*** |
| `title` | string | *title of the element* |
| `url` | string | *search URL with refinement parameters* |
| `domain` | string | *domain in SERP* |
| `item_types` | array | *types of search results in SERP*   contains types of search results (`items`) found in SERP.   possible item types:   `autocomplete` |
| `se_results_count` | integer | *total number of results in SERP* |
| `items_count` | integer | *the number of results returned in the **`items`** array* |
| **`items`** | array | *elements of search results found in SERP* |
| `type` | string | *type of element = **‘autocomplete’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `relevance` | integer | *relevance of suggested keyword*   represents the relevance of the autocomplete suggestion to the target keyword   can take values from `500` to `2000`   the higher the value, the more relevant is the suggestion   **Note:** only available for the following `client`:   `chrome/chrome-omni` |
| `suggestion` | string | *google autocomplete keyword suggestion* |
| `suggestion_type` | string | *google autocomplete suggestion type*   **Note:** only available for the following `client`:   `chrome/chrome-omni` |
| `search_query_url` | string | *url to search results*   url to search results relevant to the google autocomplete suggestion |
| `thumbnail_url` | string | *url of the thumbnail image*   url of the thumbnail image of google autocomplete suggestion   **Note:** only available for the following `client`:   `gws-wiz`   `gws-wiz-serp` |
| `highlighted` | array | *keywords highlighted in autocomplete*   contains a list of google autocomplete suggestions that are highlighted in the search bar;   **Note:** array is only available for the following `client`:   `gws-wiz`   `psy-ab`   `gws-wiz-local` |



 

 









> Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

```
# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/serp/google/autocomplete/live/advanced" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "language_code": "en",
        "location_code": 2840,
        "keyword": "albert einstein",
        "client": "gws-wiz-serp"
    }
]'
```





```php
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
    // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
    $client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
    echo "n";
    print "HTTP code: {$e->getHttpCode()}n";
    print "Error code: {$e->getCode()}n";
    print "Message: {$e->getMessage()}n";
    print  $e->getTraceAsString();
    echo "n";
    exit();
}
$post_array = array();
// You can set only one task at a time
$post_array[] = array(
   "language_code" => "en",
   "location_code" => 2840,
   "keyword" => "albert einstein",
   "cursor_pointer" => "6"
);
try {
    // POST /v3/serp/google/autocomplete/live/advanced
    // in addition to 'google' and 'autocomplete' you can also set other search engine and type parameters
    // the full list of possible parameters is available in documentation
    $result = $client->post('/v3/serp/google/autocomplete/live/advanced', $post_array);
    print_r($result);
    // do something with post result
} catch (RestClientException $e) {
    echo "n";
    print "HTTP code: {$e->getHttpCode()}n";
    print "Error code: {$e->getCode()}n";
    print "Message: {$e->getMessage()}n";
    print  $e->getTraceAsString();
    echo "n";
}
$client = null;
?>
```





```js
const axios = require('axios');

axios({
    method: 'post',
    url: 'https://api.dataforseo.com/v3/serp/google/autocomplete/live/advanced',
    auth: {
        username: 'login',
        password: 'password'
    },
    data: [{
        "keyword": encodeURI("albert einstein"),
        "language_code": "en",
        "location_code": 2840,
        "cursor_pointer": 6
    }],
    headers: {
        'content-type': 'application/json'
    }
}).then(function (response) {
    var result = response['data']['tasks'];
    // Result data
    console.log(result);
}).catch(function (error) {
    console.log(error);
});
```





```python
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# You can set only one task at a time
post_data[len(post_data)] = dict(
    language_code="en",
    location_code=2840,
    keyword="albert einstein",
    cursor_pointer=6
)
# POST /v3/serp/google/autocomplete/live/advanced
# in addition to 'google' and 'autocomplete' you can also set other search engine and type parameters
# the full list of possible parameters is available in documentation
response = client.post("/v3/serp/google/autocomplete/live/advanced", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
```





```csharp
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task serp_live_advanced()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                //DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            // You can set only one task at a time
            postData.Add(new
            {
                language_code = "en",
                location_code = 2840,
                keyword = "albert einstein",
                cursor_pointer = 6
            });
            // POST /v3/serp/google/autocomplete/live/advanced
            // in addition to 'google' and 'autocomplete' you can also set other search engine and type parameters
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/serp/google/autocomplete/live/advanced", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}
```





> The above command returns JSON structured like this:

```
{
  "version": "0.1.20240514",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "2.0961 sec.",
  "cost": 0.002,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "05302148-1535-0139-0000-6ff42f88c792",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "2.0246 sec.",
      "cost": 0.002,
      "result_count": 1,
      "path": [
        "v3",
        "serp",
        "google",
        "autocomplete",
        "live",
        "advanced"
      ],
      "data": {
        "api": "serp",
        "function": "live",
        "se": "google",
        "se_type": "autocomplete",
        "language_code": "en",
        "location_code": 2840,
        "keyword": "albert einstein",
        "client": "gws-wiz-serp",
        "device": "desktop",
        "os": "windows"
      },
      "result": [
        {
          "keyword": "albert einstein",
          "type": "autocomplete",
          "se_domain": "google.com",
          "location_code": 2840,
          "language_code": "en",
          "check_url": "https://google.com/search?q=albert+einstein&hl=en&gl=US&uule=w+CAIQIFISCQs2MuSEtepUEUK33kOSuTsc",
          "datetime": "2024-05-30 18:49:01 +00:00",
          "spell": null,
          "refinement_chips": null,
          "item_types": [
            "autocomplete"
          ],
          "se_results_count": 0,
          "items_count": 10,
          "items": [
            {
              "type": "autocomplete",
              "rank_group": 1,
              "rank_absolute": 1,
              "relevance": null,
              "suggestion": "albert einstein",
              "suggestion_type": null,
              "search_query_url": "https://www.google.com/search?q=albert+einstein",
              "thumbnail_url": "http://t0.gstatic.com/images?q=tbn:ANd9GcSFn2iZxs3MN8ja-4Gx7maVbATd52RTpRCrJ-WljxMFWeszvflAZjtziuiRdQ&s=10",
              "highlighted": null
            },
            {
              "type": "autocomplete",
              "rank_group": 2,
              "rank_absolute": 2,
              "relevance": null,
              "suggestion": "albert einstein college of medicine",
              "suggestion_type": null,
              "search_query_url": "https://www.google.com/search?q=albert+einstein+college+of+medicine",
              "thumbnail_url": "http://t0.gstatic.com/images?q=tbn:ANd9GcSa9iqJoNmJhras1iH1oiUx2UMCZVM_5VFmPjJXvE-K&s=10",
              "highlighted": null
            },
            {
              "type": "autocomplete",
              "rank_group": 3,
              "rank_absolute": 3,
              "relevance": null,
              "suggestion": "albert einstein iq",
              "suggestion_type": null,
              "search_query_url": "https://www.google.com/search?q=albert+einstein+iq",
              "thumbnail_url": null,
              "highlighted": [
                "iq"
              ]
            },
            {
              "type": "autocomplete",
              "rank_group": 4,
              "rank_absolute": 4,
              "relevance": null,
              "suggestion": "albert einstein death",
              "suggestion_type": null,
              "search_query_url": "https://www.google.com/search?q=albert+einstein+death",
              "thumbnail_url": null,
              "highlighted": [
                "death"
              ]
            },
            {
              "type": "autocomplete",
              "rank_group": 5,
              "rank_absolute": 5,
              "relevance": null,
              "suggestion": "albert einstein quotes",
              "suggestion_type": null,
              "search_query_url": "https://www.google.com/search?q=albert+einstein+quotes",
              "thumbnail_url": "http://t0.gstatic.com/images?q=tbn:ANd9GcRnmMaYbKfIi4s248o1yaRqUZUCsaoJxjiS4BA_s2d8h-WKhBkVbPU98CW-Xw&s=10",
              "highlighted": null
            },
            {
              "type": "autocomplete",
              "rank_group": 6,
              "rank_absolute": 6,
              "relevance": null,
              "suggestion": "albert einstein news",
              "suggestion_type": null,
              "search_query_url": "https://www.google.com/search?q=albert+einstein+news",
              "thumbnail_url": null,
              "highlighted": [
                "news"
              ]
            },
            {
              "type": "autocomplete",
              "rank_group": 7,
              "rank_absolute": 7,
              "relevance": null,
              "suggestion": "albert einstein wife",
              "suggestion_type": null,
              "search_query_url": "https://www.google.com/search?q=albert+einstein+wife",
              "thumbnail_url": null,
              "highlighted": [
                "wife"
              ]
            },
            {
              "type": "autocomplete",
              "rank_group": 8,
              "rank_absolute": 8,
              "relevance": null,
              "suggestion": "albert einstein brain",
              "suggestion_type": null,
              "search_query_url": "https://www.google.com/search?q=albert+einstein+brain",
              "thumbnail_url": null,
              "highlighted": [
                "brain"
              ]
            },
            {
              "type": "autocomplete",
              "rank_group": 9,
              "rank_absolute": 9,
              "relevance": null,
              "suggestion": "albert einstein inventions",
              "suggestion_type": null,
              "search_query_url": "https://www.google.com/search?q=albert+einstein+inventions",
              "thumbnail_url": null,
              "highlighted": [
                "inventions"
              ]
            },
            {
              "type": "autocomplete",
              "rank_group": 10,
              "rank_absolute": 10,
              "relevance": null,
              "suggestion": "albert einstein hospital",
              "suggestion_type": null,
              "search_query_url": "https://www.google.com/search?q=albert+einstein+hospital",
              "thumbnail_url": null,
              "highlighted": [
                "hospital"
              ]
            }
          ]
        }
      ]
    }
  ]
}
```









 

  cURL   php   Node.js   Python   cSharp